#!/usr/bin/python
# -*- coding: UTF-8 -*-

#Python开发接口更新版v0.2
#说明 
#本代码仅适用于金笛短信WEB中间件http接口，基于web中间件《开发接口说明文档》编写

#使用方法
#1.修改服务器IP，端口，密码等参数
#2.运行本代码，看看在当前配置下是否正常将消息插入到待发送队列
#3.将本代码适配后，加入到您的项目中
#
#常见问题
#1.SSL无法访问：
#  确保requests.get中有verify= False参数，不验证证书即可
#
#2.访问显示乱码
#  需要使用https访问中间件的接口
#
#3.接口调用出现错误
#  返回的错误参数说明  -9000：参数非法，-9001：缺少参数， -9002：发送错误，-9003：密码错误， -9999：发送终止 ;
#
#4.无法将新数据加入到待发送列表中
#  (1)确保中间件的数据库可用并已连上(详见数据源设置页面)
#  (2)http接口调用时添加了不适当的参数
#
#5.更改http API的端口号
#  端口可以在配置文件中更改，在安装目录conf/JDSMSServer.conf中，httpServer.port参数的值即为API的端口
#
#6.短信发不出去
#  (1)检查待发送列表是否有数据
#  (2)直接访问API的网址，查看是否有返回
#  (3)直接在中间件发送一条短信，并在[设备配置]或[短信设备]中确认设备处于[启用]状态
#  (4)设备显示[未授权]时,中间件可用于测试，但会随机附带"金笛短信为您服务"，而且有88条的数量限制，请留意是否已用完测试限额
#
#7.发出去的短信乱码\待发送列表中短信内容显示乱码
#  一般是编码问题，请将发出去的文字编码设置为UTF-8
#
#8.发出去的短信多了"金笛短信为您服务"的字样
#  说明您的中间件尚未注册，进入实际生产环境阶段之前请将设备

#建议：在开发期间，只要待发送列表能显示插入的消息，即可确认接口程序成功建立连接，故建议不要在调试期间开启设备
#高版本中间件可以一次发送多条短信，收件人用";"分隔后以字符串形式输入即可，如"138001380138;138001380139;18901890189",中间件会自动处理

import requests
import urllib3
urllib3.disable_warnings(urllib3.exceptions.InsecureRequestWarning)


#sendsms_ssl函数参数说明
#recipient:[必填,变量]收件人，单次访问建议只填写一个收件人
#text:[必填,变量]短信内容
#ip:[可选,常量]指安装中间件的服务器IP，在下方ip='127.0.0.1'这里可以更改默认地址
#port:[可选,常量]指中间件的接口端口，一般为8060，更改方式见上方常见问题
#ssl:[可选,常量]中间件版本高于3.6.8时默认开启SSL，开启SSL时请选择True，否则为False
#返回值:获取到的服务器返回值，XML格式

def sendsms_ssl(recipient,text,ip='127.0.0.1',port='8060',ssl=False):
    params = {
    'text' : text,
    'recipient' : recipient,
    'password' : 1,
    'encoding' : 'U'
    }
    print('本次连接使用的参数:',params)
    if ssl==True:
        resp = requests.get(url='%s://%s:%s/send'%('https',ip,port),params=params,verify= False)  #使用SSL时，需要将证书验证关闭
    else:
        resp = requests.get(url='%s://%s:%s/send'%('http',ip,port),params=params)
    resp.encoding = 'utf-8'
    print(resp.text)
    return resp.text
    
#参考调用方法,请先修改服务器IP，端口，密码等参数再调用
sendsms_ssl("10086","你好！",'192.168.0.1','8060',False)

#这个是3.6.7版本之前中间件可用的函数，仅作示例用
#参考调用方法
#sendsms("10086","你好！")
def sendsms(recipient,text):
    params = {
    'text' : text,
    'recipient' : recipient,
    'password' : 1,
    'encoding' : 'U',
    }
    print(params)
    post_url='http://127.0.0.1:8060/send'
    resp = requests.get(url=post_url,params=params)
    resp.encoding = 'utf-8'
    print(resp.text)